unit Create;

interface

uses Windows, ioctl, ifc_ldev;

type
  TCreateInstance = function(Slot:ULONG): LUnknown; cdecl;

var
  hModule: THandle;
  CreateInstance: TCreateInstance;

  function CallCreateInstance(name:PChar):ULONG;

implementation

function CallCreateInstance(name:PChar):ULONG;
begin
   hModule:=0;
   hModule:=LoadLibrary(name);
   if(hModule=0) then
   begin
//      MessageBox(0,'Unable load dll','Error',MB_OK);
      Result:=0;
      Exit;
   end;
   @CreateInstance:=GetProcAddress(hModule,'CreateInstance');
   if(@CreateInstance=nil) then
   begin
//      MessageBox(0,'Unable find CreateInstance','Error',MB_OK);
      Result:=0;
      Exit;
   end;
   Result:=1;
end;


end.
