#include <stdio.h>
#include <string.h>

#include "../include/stubs.h"
#include "../include/ioctl.h"
#include "../include/salayer.h"
#include "../include/pcicmd.h"

#include "../include/ifc_ldev.h"
#include "../include/ldevbase.h"
#include "../include/lcpi.h"


FDF(ULONG) DaqLCPI::LoadBios(char *FileName)
{
USHORT  *LCBios;
FILE *BiosFile;
LONG   NBytes;
PUCHAR  BiosCode =0;
USHORT  *Tmp;
USHORT  Count;
CHAR  FName[255];
//ULONG cbRet;
//ULONG data;

   int status = L_ERROR;
   do
   {
      strcpy(FName,FileName);
      strcat(FName,".bio");
      BiosFile=fopen(FName, "rb");
      if(!BiosFile) { break; }
      fseek(BiosFile,0,SEEK_END);
      NBytes = ftell(BiosFile);
      rewind(BiosFile);

      BiosCode=new UCHAR[NBytes+2];
      if (BiosCode == NULL) break;
      if(fread(BiosCode,1,NBytes,BiosFile) != NBytes)  break;
      LCBios=(PUSHORT)BiosCode;

/*
		status = 2105;
      USHORT dd = 0x40;
		outmword(0xC, &dd);
		inmword(0xC,&dd);
		if((dd&0xC0)==0x40)
		{
         dd = 0x80;
			outmword(0xC, &dd);		
			inmword(0xC,&dd);			
			if((dd&0xC0)==0x80) status = 2185;
		}
*/
      // RESET  ADSP-218x //   ioctl
      USHORT rst = 0x0;
      outmword(/*sl.IDMA_REG*/0xC, &rst); // IDMA -  CFG  RDY 
      outmword(/*sl.DTA_REG*/0x0, &LCBios[1]);
      rst = 0x08;
      outmword(/*sl.IDMA_REG*/0xC, &rst); // IDMA -  CFG  RDY 

      Tmp=&LCBios[2];//LCBios+2;
      Count=(USHORT)(LCBios[0]-1);
      PutArray_DM(0x0001,Count,Tmp); //   
      PutWord_DM(0x0001,0); //  
		
      USHORT d = 0;

		//for(int i=0; i<100;i++) inmword(0xC,&d);
      
      GetWord_DM(0x0000,&d);
      if(d!=5) { status = d; break;} //   pm

      // Load DSP DM word
      Tmp=LCBios+LCBios[0]+1; // calculate DM address &LCBios[0]+LCBios[0]
      Count=*Tmp;           // counter
      Tmp++;

      PutWord_DM(0x0000,Count);
      PutArray_DM(0x0000, Count,Tmp);
      GetWord_DM(0x0000,&d);
      if(d!=4) { status = d; break;} //   dm

      if(PlataTest()!=L_SUCCESS) { status = 0x7777; break; }

      status = L_SUCCESS;
   } while (status==L_ERROR);
   //      
   if(BiosCode) delete[] BiosCode;
   if(BiosFile) fclose(BiosFile);
   return status;
}

