#define IFC(type) virtual type __stdcall

#define FDF(type) type __stdcall

#ifndef __LUNKNOWN__
#define __LUNKNOWN__
struct LUnknown
{
   IFC(HRESULT)   QueryInterface(const IID& iid, void** ppv) = 0;
   IFC(ULONG)     AddRef() = 0;
   IFC(ULONG)     Release() = 0;
};
#endif

struct IZoomer:LUnknown
{
   IFC(ULONG) GetInfo(OSCInfo *) = 0;
   IFC(ULONG) SetParameters(int Prop, ZoomParam *zp=0) =0;
   IFC(ULONG) SetDataI(int *Data, int Size, int Chan, int ActCh, ZoomScale *zs, COLORREF *rgb=0) =0;
   IFC(ULONG) MakeFont(HWND hWnd, int H, char *Name=0) =0;
   IFC(ULONG) OnPaint(HDC dc, RECT &rect, int) =0;
   IFC(ULONG) OnMouseMove(RECT &rect, WPARAM wParam, LPARAM lParam) =0;
   IFC(ULONG) OnButtonDown(RECT &rect, WPARAM wParam, LPARAM lParam, int Mode = 0) =0;
};

// {9384B964-761D-416e-BAD9-ABC7B4C9A942}
DEFINE_GUID(IID_IZOOMER, 0x9384b964, 0x761d, 0x416e, 0xba, 0xd9, 0xab, 0xc7, 0xb4, 0xc9, 0xa9, 0x42);
