#include <windows.h>
#include <stdio.h>
#include <conio.h>
#include <iostream>


#include "..\include\ioctl.h"
#include "..\include\wlcomp.h"
#include "..\include\e2010cmd.h"

using namespace std;

ULONG hIfc;
ULONG hIfc2;

USHORT   *fdata;
HANDLE hFile, hMap;
long fsize;

USHORT *data;
ULONG *sync;

USHORT *data1;
ULONG *sync1;


ULONG status;
USHORT complete;

HANDLE hThread;
ULONG Tid;

ULONG IrqStep = 2048;//777-777%7; //     
ULONG FIFO = 2048;         //
ULONG pages = 32;
ULONG multi = 8; // -    ,    


//      
#pragma optimize ("", off)
ULONG WINAPI ServiceThread(PVOID /*Context*/)
{
   ULONG halfbuffer = IrqStep*pages/2;             //    
   ULONG syncd;
   ULONG i;
   GetSyncData(&hIfc, (ULONG)sync, 0, &syncd);
   ULONG fl2,fl1 = fl2 = (syncd<=halfbuffer)? 0:1; //  
   USHORT *tmp, *tmp1;
   for(i=0;i<multi;i++)                        //     
   {
      while(fl2==fl1)
      {
         GetSyncData(&hIfc, (ULONG)sync, 0, &syncd);
         fl2=(syncd<=halfbuffer)? 0:1; //    
      }
      tmp=fdata+(halfbuffer*i);                    //    
      tmp1=data+(halfbuffer*fl1);                  //     

      memcpy(tmp,tmp1,halfbuffer*sizeof(USHORT));//    
      //GetDataFromBuffer(&hIfc, (ULONG)tmp1, tmp, halfbuffer*sizeof(USHORT),0);

      GetSyncData(&hIfc, (ULONG)sync, 0,&syncd);
      fl1=(syncd<=halfbuffer)? 0:1;                //  
      Sleep(0);                                    //        
   }
   complete=1;                                     //    
  return 0;                                          // 
}
#pragma optimize ("", on)


int main(int argc, char *argv[])
{
ULONG hDll;
ULONG Err;
WDAQ_PAR adcPar;
WDAQ_PAR dacPar;
PLATA_DESCR_U2 pd;
SLOT_PAR sl;
ULONG slot = 0;

   if(argc==1)
   {
      cout << "WLCOMP simple example (L761,L780,L783,E440,E140,E2010)." << endl;
      cout << "(c) 2008 L-Card." << endl;
      cout << "Usage:" << endl;
      cout << "   client <slot number> <bios name>" << endl;
      cout << "   <slot number> - 0... (if one board installed - 0);" << endl;
      cout << "   <bios name>  - bios name without extension(l761 l780 l783);" << endl;
      exit(1);
   }
   if(argc<3)
   {
      cout << "no params - exit!" << endl;
      exit(1);
   }

   hDll = LoadAPIDLL("lcomp.dll");

   hIfc = (ULONG)CallCreateInstance(&hDll, atoi(argv[1]),&Err); // return handle for new iface

   hIfc2 = (ULONG)Get_LDEV2_Interface(&hIfc, &Err);

   Err = OpenLDevice(&hIfc);
   cout << "OpenLDevice Handle " << hex << Err << endl;
   Err = LoadBios(&hIfc, argv[2]);
   cout << "LoadBios status " << Err << endl;
   Err = PlataTest(&hIfc);
   cout << "Plata test " << Err << endl;

   cout << endl << "Slot parameters" << endl;   
   GetSlotParam(&hIfc, &sl);

   cout << "Base    " << hex << sl.Base << endl;
   cout << "BaseL   " << sl.BaseL << endl;
   cout << "Mem     " << sl.Mem << endl;
   cout << "MemL    " << sl.MemL << endl;
   cout << "Type    " << sl.BoardType << endl;
   cout << "DSPType " << sl.DSPType << endl;
   cout << "Irq     " << sl.Irq << endl;

   cout << endl << "Press any key" << dec << endl;
   _getch();


   cout << endl << "Read FLASH" << endl;
   ReadPlataDescr(&hIfc, &pd); // fill up properties

   switch (sl.BoardType)
   {
   case PCIA:
   case PCIB:
   case PCIC:  {
                  cout << "SerNum       " << pd.t1.SerNum << endl;
                  cout << "BrdName      " << pd.t1.BrdName << endl;
                  cout << "Rev          " << pd.t1.Rev << endl;
                  cout << "DspType      " << pd.t1.DspType << endl;
                  cout << "IsDacPresent " << pd.t1.IsDacPresent << endl;
                  cout << "Quartz       " << dec << pd.t1.Quartz << endl;
               } break;
   case E140:  {
                  cout << "SerNum       " << pd.t5.SerNum << endl;
                  cout << "BrdName      " << pd.t5.BrdName << endl;
                  cout << "Rev          " << pd.t5.Rev << endl;
                  cout << "DspType      " << pd.t5.DspType << endl;
                  cout << "IsDacPresent " << pd.t5.IsDacPresent << endl;
                  cout << "Quartz       " << dec << pd.t5.Quartz << endl;
               } break;
   case E154:  {
                  cout << "SerNum       " << pd.t7.SerNum << endl;
                  cout << "BrdName      " << pd.t7.BrdName << endl;
                  cout << "Rev          " << pd.t7.Rev << endl;
                  cout << "DspType      " << pd.t7.DspType << endl;
                  cout << "IsDacPresent " << pd.t7.IsDacPresent << endl;
                  cout << "Quartz       " << dec << pd.t7.Quartz << endl;
               } break;
   
   case E440:  {
                  cout << "SerNum       " << pd.t4.SerNum << endl;
                  cout << "BrdName      " << pd.t4.BrdName << endl;
                  cout << "Rev          " << pd.t4.Rev << endl;
                  cout << "DspType      " << pd.t4.DspType << endl;
                  cout << "IsDacPresent " << pd.t4.IsDacPresent << endl;
                  cout << "Quartz       " << dec << pd.t4.Quartz << endl;
               } break;
   case E2010B:
   case E2010: {
                  cout << "SerNum       " << pd.t6.SerNum << endl;
                  cout << "BrdName      " << pd.t6.BrdName << endl;
                  cout << "Rev          " << pd.t6.Rev << endl;
                  cout << "DspType      " << pd.t6.DspType << endl;
                  cout << "IsDacPresent " << pd.t6.IsDacPresent << endl;
                  cout << "Quartz       " << dec << pd.t6.Quartz << endl;
               }
   }

   cout << endl << "Press any key" << dec << endl;
   _getch();

// digital line test IoAsync example call
   WASYNC_PAR pp;

   pp.s_Type = L_ASYNC_TTL_OUT;
   pp.Data[0] = 0xA525;
   cout << IoAsync(&hIfc, &pp) << endl;

   pp.s_Type = L_ASYNC_TTL_INP;
   pp.Data[0] = 1;
   cout << IoAsync(&hIfc, &pp) << endl;

   cout << "TTL input " << hex << pp.Data[0] << endl;  
   cout << endl << "TTL io test " << dec << endl;


// DAC ///////////////////////////////////////////

   dacPar.t1.s_Type = L_DAC_PARAM;
   dacPar.t1.AutoInit=0;
   dacPar.t1.dRate=30.0;       // for e140m dac - very limited set of freq value
   dacPar.t1.FIFO=1024; // 512
   dacPar.t1.IrqStep=4096; // 512
   dacPar.t1.Pages=4; //2
   dacPar.t1.IrqEna=1;
   dacPar.t1.DacEna=1;
   
   FillDAQparameters(&hIfc,&dacPar,0);

   ULONG db=512000;

   RequestBufferStream(&hIfc, &db, L_STREAM_DAC);

   //pI->SetParametersStream(&dacPar.t1,&db, (void **)&data1, (void **)&sync1,L_STREAM_DAC);
   SetParametersStream(&hIfc, &dacPar, 0, &db, (void **)&data1, (void **)&sync1,L_STREAM_DAC);

// internal RAM PCI
//   for(int i=0;i<1024;i+=2) data1[i]=((USHORT)(1024.0*sin((2.0*(3.1415*i)/1024.0)))&0xFFF)|0x0000;
//   for(int i=1;i<1024;i+=2) data1[i]=((USHORT)(1024.0*sin((2.0*(3.1415*i)/1024.0)))&0xFFF)|0x1000;

// DAC streaming for E140M
   for(int i=0;i<2048*8;i++) data1[i]=(USHORT)(16384*sin((2.0*(3.1415*i)/1024.0))); // for e140m stream

// DAC streaming for PCI and E440
//   for(int i=0;i<2048*8;i++) data1[i]=((USHORT)(2048*sin((2.0*(3.1415926*i)/8192.0)))&0xFFF)|0x0000; // for all
   data1[64] = 512;
   data1[65] = 512;
   data1[66] = 512;
   data1[67] = 512;
   data1[68] = 512;
   data1[69] = 512;
   data1[70] = 512;
   data1[71] = 512;
   data1[72] = 512;
/////////////////////////////////////////////


   DWORD tm = 10000000;  //   512000 
   RequestBufferStream(&hIfc,&tm,L_STREAM_ADC);
   cout << "Allocated memory size(word): " << tm << endl;

   //   
   switch(sl.BoardType)
   {
   case PCIA:
   case PCIB:
   case PCIC:
   case E440:
   case E140:
   case E154:
      {
         adcPar.t3.s_Type = L_ADC_PARAM;
         adcPar.t3.AutoInit = 1;
         adcPar.t3.dRate = 100.0;
         adcPar.t3.dKadr = 0;
         adcPar.t3.dScale = 0;
         adcPar.t3.SynchroType = 3;
         if(sl.BoardType==E440 || sl.BoardType==E140 || sl.BoardType==E154) adcPar.t3.SynchroType = 0;
         adcPar.t3.SynchroSensitivity = 0;
         adcPar.t3.SynchroMode = 0;
         adcPar.t3.AdChannel = 0;
         adcPar.t3.AdPorog = 0;
         adcPar.t3.NCh = 4;
         adcPar.t3.Chn[0] = 0x0;
         adcPar.t3.Chn[1] = 0x1;
         adcPar.t3.Chn[2] = 0x2;
         adcPar.t3.Chn[3] = 0x3;
         adcPar.t3.FIFO = 1024;
         adcPar.t3.IrqStep = 1024;
         adcPar.t3.Pages = 128;
         if(sl.BoardType==E440 || sl.BoardType==E140 || sl.BoardType==E154)
         {
            adcPar.t3.FIFO = 4096;
            adcPar.t3.IrqStep = 4096;
            adcPar.t3.Pages = 32;
         }
         adcPar.t3.IrqEna = 1;
         adcPar.t3.AdcEna = 1;

         FillDAQparameters(&hIfc, &adcPar, 2);
         SetParametersStream(&hIfc, &adcPar, 2, &tm, (void **)&data, (void **)&sync,L_STREAM_ADC);

         cout << "Buffer size(word): " << tm << endl;
         cout << "Pages:             " << adcPar.t3.Pages << endl;
         cout << "IrqStep:           " << adcPar.t3.IrqStep << endl;
         cout << "FIFO:              " << adcPar.t3.FIFO << endl;
         cout << "Rate:              " << adcPar.t3.dRate << endl;
         cout << "Kadr:              " << adcPar.t3.dKadr << endl;

         IrqStep = adcPar.t3.IrqStep;
         pages = adcPar.t3.Pages;

      } break;

   case E2010B:
   case E2010:
      {
         adcPar.t4.s_Type = L_ADC_PARAM;
         adcPar.t4.AutoInit = 1;
         adcPar.t4.dRate = 1000.0;
         adcPar.t4.dKadr = 0.001;
         adcPar.t4.SynchroType = 0x01;
         adcPar.t4.AdcIMask = SIG_0|SIG_1|SIG_2|SIG_3;
         
         adcPar.t4.NCh = 4;
         adcPar.t4.Chn[0] = 0x0;
         adcPar.t4.Chn[1] = 0x1;
         adcPar.t4.Chn[2] = 0x2;
         adcPar.t4.Chn[3] = 0x3;
         adcPar.t4.FIFO = 32768;
         adcPar.t4.IrqStep = 32768;
         adcPar.t4.Pages = 32;
         adcPar.t4.IrqEna = 1;
         adcPar.t4.AdcEna = 1;

         FillDAQparameters(&hIfc, &adcPar.t4, 3);
         cout << "Buffer size(word): " << tm << endl;
         cout << "Pages:             " << adcPar.t4.Pages << endl;
         cout << "IrqStep:           " << adcPar.t4.IrqStep << endl;
         cout << "FIFO:              " << adcPar.t4.FIFO << endl;
         cout << "Rate:              " << adcPar.t4.dRate << endl;

         SetParametersStream(&hIfc, &adcPar.t4, 3, &tm, (void **)&data, (void **)&sync,L_STREAM_ADC);

         cout << "Buffer size(word): " << tm << endl;
         cout << "Pages:             " << adcPar.t4.Pages << endl;
         cout << "IrqStep:           " << adcPar.t4.IrqStep << endl;
         cout << "FIFO:              " << adcPar.t4.FIFO << endl;
         cout << "Rate:              " << adcPar.t4.dRate << endl;

         IrqStep = adcPar.t4.IrqStep;
         pages = adcPar.t4.Pages;

      }
   }

   cout << endl << "Press any key" << dec << endl;
   _getch();


   cout << "Started ..." << endl;
//  
   fsize=multi*(pages/2)*IrqStep; //  

   hFile=CreateFile("data.dat",GENERIC_READ|GENERIC_WRITE,FILE_SHARE_WRITE,
                               NULL,CREATE_ALWAYS,FILE_FLAG_RANDOM_ACCESS,NULL);

   if(hFile==INVALID_HANDLE_VALUE){ MessageBox(0,"File open error","Error",MB_OK|MB_ICONERROR);goto end;}

   hMap=CreateFileMapping(hFile,NULL,PAGE_READWRITE,0,fsize*2,NULL);

   if(hMap==NULL){MessageBox(0,"File open error","Error",MB_OK|MB_ICONERROR);goto end;}

   fdata=(WORD *)MapViewOfFile(hMap,FILE_MAP_WRITE,0,0,0);

   complete=0;

   EnableCorrection(&hIfc, 1);

// start DAC
//   InitStartLDeviceEx(&hIfc2,L_STREAM_DAC); // зачистили переменные внутри драйвера
//   StartLDeviceEx(&hIfc2,L_STREAM_DAC); // запустили сбор


//    
   //InitStartLDevice(&hIfc);
   InitStartLDeviceEx(&hIfc2,L_STREAM_ADC);

//      
   hThread=CreateThread(0,0x2000,ServiceThread,0,0,&Tid);

   //    
   //status = StartLDevice(&hIfc);
   status = StartLDeviceEx(&hIfc2,L_STREAM_ADC);

   //    
   while(!complete)
   {
      ULONG syncd;
      GetSyncData(&hIfc, (ULONG)sync, 0, &syncd);
      cout << syncd << endl;
      Sleep(20);
   }

   cout << "StartLDevice returned " <<  (status ? "TRUE":"FALSE") << endl;

   //StopLDevice(&hIfc); //  
   StopLDeviceEx(&hIfc2,L_STREAM_ADC); //  

end:

   Release_LDEV2_Interface(&hIfc2);

   CloseLDevice(&hIfc);

   CloseHandle(hThread);

   UnmapViewOfFile(fdata);
   CloseHandle(hMap);
   CloseHandle(hFile);
   FreeAPIDLL(&hDll);
   cout << "Exit" << endl;
   return 0;
}
