/*================================================================================================*
 *     USB (control channel) * *
 *================================================================================================*/

#ifndef USB_CONTROL_H_
#define USB_CONTROL_H_

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
void USBCTL_Read                    /*     */
    (
    unsigned int USBRequestSize,    /* ()  -   */
    void *pBuffer,                  /* ()  -    */
    unsigned int BufferSize         /* ()  -   (    USBRequestSize) */
    );
/*------------------------------------------------------------------------------------------------*/
void USBCTL_Write                   /*     */
    (
    unsigned int USBRequestSize,    /* ()  -   */
    void *pBuffer,                  /* ()  -    */
    unsigned int BufferSize         /* ()  -   (    USBRequestSize) */
    );
/*------------------------------------------------------------------------------------------------*/
void USBCTL_RequestError            /*   ( stall) */
    (void);
/*------------------------------------------------------------------------------------------------*/
void USBCTL_RequestOK               /*   (  ) */
    (void);
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/

#endif /* USB_CONTROL_H_ */
