#ifndef MAIN_H_
#define MAIN_H_

#include "flash.h"

/*================================================================================================*/
#define BOOTROM_VERSION             0x0106

/*        */
#define MAIN_RUN_USER_FIRMWARE      0x4000
#define MAIN_ENTER_SLEEP_MODE       0x2000
#define MAIN_EXIT_SLEEP_MODE        0x1000

/*        USB SUSPEND */
#define MAIN_SLEEP_ON_USB_SUSPEND   0
/*================================================================================================*/

/*================================================================================================*/
extern unsigned int g_MainFlag;
extern int g_FW_Valid;
extern const t_FLASH_Metadata *g_FW_pMeta;
/*================================================================================================*/

#endif /* MAIN_H_ */
