#include "USBHardware.h"

/*
,    USB
 - ,     
*/
__arm void USB_Interrupt_Handler_Continue(uint InterruptStatus)
{
    if (InterruptStatus&AT91C_UDP_ENDBUSRES)  EndBusResProcessing();

    if (InterruptStatus&(1<<CONTROL_ENDPOINT))
    {
        if (AT91C_BASE_UDP->UDP_CSR[CONTROL_ENDPOINT]&AT91C_UDP_RXSETUP)
        {
            ControlCommandProcessing();
        }
        else
        {
      //  if(!BackgroundControlOn)
          AT91C_BASE_UDP->UDP_CSR[CONTROL_ENDPOINT]&=~(AT91C_UDP_TXCOMP|AT91C_UDP_RX_DATA_BK0|AT91C_UDP_RX_DATA_BK1|AT91C_UDP_ISOERROR); //  ,   
        }
    }

    if (InterruptStatus&AT91C_UDP_RXRSM)  ExitSleepMode();
    if (InterruptStatus&AT91C_UDP_RXSUSP) EnterSleepMode();

    Clear_Usb_Interrupts(InterruptStatus);
}
