/*================================================================================================*
 *   -
 *================================================================================================*/

#include "pio.h"

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
void PIO_Init                       /*   (  PA0) */
    (void)
    {
    /*   PIO */
    AT91C_BASE_PMC->PMC_PCER = (1 << AT91C_ID_PIOA);

    /*      PIO (   ) */
    AT91C_BASE_PIOA->PIO_ODR = 0xFFFFFFFF; /*   -  */
    AT91C_BASE_PIOA->PIO_PER = 0xFFFFFFFF;

    /*      */
    AT91C_BASE_PIOA->PIO_CODR =
            PIO_LED;
    AT91C_BASE_PIOA->PIO_SODR =
            PIO_NPCS3         /* EEPROM   */
          | PIO_LOW_POWER;    /*    standby */
    /*    */
    AT91C_BASE_PIOA->PIO_OER =
            PIO_LED
          | PIO_NPCS3
          | PIO_LOW_POWER;

    /*   pull-up */
    AT91C_BASE_PIOA->PIO_PPUDR = 0xFFFFFFFF;
    /*    */
    AT91C_BASE_PIOA->PIO_IFDR = 0xFFFFFFFF;
    /*   multidrive */
    AT91C_BASE_PIOA->PIO_MDDR = 0xFFFFFFFF;

    /*   PIO_N_RESET  multidrive (drive only low level) */
    AT91C_BASE_PIOA->PIO_MDER = PIO_N_RESET;
    }
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
