#ifndef CONFIGURE_USB_H_
#define CONFIGURE_USB_H_

/*================================================================================================*/
#define DEVICE_VID 0x0471
#define DEVICE_PID 0x0140

#define USBSTR_MANUFACTURER_ENG     U('L'),U('-'),U('C'),U('A'),U('R'),U('D')

#define USBSTR_MANUFACTURER_RUS     U(''),U('-'),U(''),U(''),U(''),U('')

#define USBSTR_PRODUCT_NAME_ENG     U('E'),U('1'),U('4'),U('0')

#define USBSTR_PRODUCT_NAME_RUS     U('E'),U('1'),U('4'),U('0')

#define USBSTR_SERIAL_NUMBER        U('0'),U('0'),U('0'),U('0'),U('0'), \
                                    U('0'),U('0'),U('0'),U('0'),U('0')

#define USBSTR_CONFIG_ENG           U('S'),U('t'),U('a'),U('n'),U('d'),U('a'),U('r'),U('d'), \
                                    U(' '),U('C'),U('o'),U('n'),U('f'),U('i'),U('g'),U('u'), \
                                    U('r'),U('a'),U('t'),U('i'),U('o'),U('n')

#define USBSTR_CONFIG_RUS           U(''),U(''),U(''),U(''),U(''),U(''),U(''),U(''), \
                                    U(''),U(''),U(''),U(' '),U(''),U(''),U(''),U(''), \
                                    U(''),U(''),U(''),U(''),U(''),U(''),U(''),U('')

#define CURRENT_CONSUMPTION_MA      400

/*  : IN =   (), OUT =   () */
/*    128    1024 */
#define USB_FIFO_IN_ARRAY_SIZE  (16 * 1024)
#define USB_FIFO_OUT_ARRAY_SIZE (16 * 1024)

#define USE_USB_BULK_INTERRUPTS_AND_FIFO 1
/*================================================================================================*/

#endif /* CONFIGURE_USB_H_ */
