#ifndef HAL_H_
#define HAL_H_

//  USB Stack Descriptors
typedef unsigned char UCHAR;
typedef unsigned short USHORT;
typedef unsigned long ULONG;
typedef unsigned int DWORD;
typedef unsigned short WORD;
typedef unsigned char BYTE;

typedef unsigned int uint;
typedef unsigned short ushort;
typedef unsigned char byte;

#include "stdbool.h"    //  bool
#include "intrinsics.h" // interrupt_enable - interrupt_disable
#include "string.h"
#include "chipio.h"
#include "clk.h"
#include "AdvInterrupt.h"
#include "USB.h"

extern __arm __ramfunc int  max(int Value1, int Value2);
extern __arm __ramfunc int  min(int Value1, int Value2);
/*
inline int max(int x1, int x2) { return (x1 >= x2)? x1 : x2; }
inline int min(int x1, int x2) { return (x1 <= x2)? x1 : x2; }
*/

extern __arm __ramfunc void AT91F_disable_interrupt(void);
extern __arm __ramfunc void AT91F_enable_interrupt(void);

#endif /* HAL_H_ */
