/*================================================================================================*
 *    
 *================================================================================================*/

#ifndef DEBUG_H_
#define DEBUG_H_

/*================================================================================================*/
#define DEBUG_OUTPUT_MCK_PCK1       0
#define DEBUG_LED_MASK              0x08 /*  PIOA */

/*    (    !) */

/*   */
#define DEBUG_LED_USB_ACTIVITY      1   /*      USB (timers.c) */

/*   */
#define DEBUG_LED_ADC_RUNNING       0   /*      */
#define DEBUG_LED_DAC_RUNNING       0   /*      */
#define DEBUG_LED_DAC_UNDERRUN      0   /*     */

#define DEBUG_LED_ADC_INTERRUPT     0   /*    (DMA) */
#define DEBUG_LED_DAC_INTERRUPT     0   /*    (DMA) */
#define DEBUG_LED_USB_INTERRUPT     0   /*   USB */
#define DEBUG_LED_TIMER_INTERRUPT   0   /*    */

#define DEBUG_LED_IRQ_DISABLED      0   /* USB  . ( IRQ  USB  ) */
#define DEBUG_LED_IRQ_ACTIVE        0   /*   IRQ (.   ) */
#define DEBUG_LED_IRQ_SPURIOUS      0   /*  spurious interrupt */
#define DEBUG_LED_IRQ_NESTED        0   /*    */

/*      */
#define DEBUG_LED_ON()              (AT91C_BASE_PIOA->PIO_SODR = DEBUG_LED_MASK)
#define DEBUG_LED_OFF()             (AT91C_BASE_PIOA->PIO_CODR = DEBUG_LED_MASK)
#define DEBUG_LED_TOGGLE()          (AT91C_BASE_PIOA->PIO_ODSR ^= DEBUG_LED_MASK)
/*================================================================================================*/

#endif /* DEBUG_H_ */
