/*================================================================================================*
 *   CRC-16  CRC-32
 *================================================================================================*/

#ifndef FASTCRC_H_
#define FASTCRC_H_

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
unsigned short CRC16_Calc           /*  CRC16 (0x1021) */
    (
    unsigned short CRC,             /* ()  -   */
    const unsigned char *pData,     /* ()  -  */
    unsigned int NumBytes           /* ()  -   */
    );
/*------------------------------------------------------------------------------------------------*/
unsigned long CRC32_Calc            /*  CRC32 (CCITT) */
    (
    unsigned long CRC,              /* ()  -   (   0) */
    const unsigned char *pData,     /* ()  -  */
    unsigned int NumBytes           /* ()  -   */
    );
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/

#endif /* FASTCRC_H_ */
