@echo off
set OCDDIR=C:\Progra~1\OpenOCD
if "%1" == "" goto fail
set HEXFILE=%1
if not exist %HEX% goto fail

start "openocd" %OCDDIR%\openocd -s %OCDDIR% -f at91sam7s_flash_wiggler.cfg

echo. > flash.nc
echo flash protect 0 0 15 off >> flash.nc
echo flash write_image erase %HEXFILE% ihex >> flash.nc
echo script end.script >> flash.nc

nc localhost 4444 < flash.nc
del flash.nc
goto end

:fail
echo Specify HEX file.
:end
