#ifndef USBCMD_H_
#define USBCMD_H_

/*================================================================================================*/
/*     ""  PUTARRAY  GETARRAY */
#define GETA_ADC_PARAMS     0x0060  /*     */
#define GETA_DAC_PARAMS     0x0160  /*     */
#define GETA_TTL_IN         0x0400  /*   TTL */
#define GETA_ADC_RESULT     0x0410  /*      */
#define GETA_NVRAM_START    0x0800  /*    NVRAM (512 ) */
                       /* ..0x09FF */
#define GETA_DAC_PRESENCE   0x0DAC  /*    */
#define GETA_CPLD_VERSION   0x1070  /*     (16 ) */
#define GETA_VERSION        0x1080  /*       */
#define GETA_DIAG_VARS      0x10C0  /*   */
                       /* ..0x10FF max */
#define GETA_DEVICE_DESCR   0x2780  /*    */
                       /* ..0x27FF */
#define GETA_TEST_RAM       0x8000  /* ()    ( ) */
                       /* ..0xFFFF */

#define PUTA_ADC_PARAMS     0x0060  /*     */
#define PUTA_NVRAM_WENABLE  0x00E9  /* /  NVRAM */
#define PUTA_DAC_PARAMS     0x0160  /*     */
#define PUTA_TTL_OUT        0x0400  /*   TTL */
#define PUTA_TTL_ENABLE     0x0402  /* /   TTL */
#define PUTA_ADC_CHANNEL    0x0412  /*       */
#define PUTA_DUMMY          0x0413  /*  */
#define PUTA_DAC_OUT_OLD    0x0420  /*    ,   (12 , 1 ) */
#define PUTA_DAC_OUT        0x0428  /*    ,   (16 , 2 ) */
#define PUTA_SUSPEND        0x0430  /*   suspend */
#define PUTA_NVRAM_START    0x0800  /* ()    NVRAM (512 ) */
                       /* ..0x09FF */
#define PUTA_DEVICE_DESCR   0x2780  /*    */
                       /* ..0x27FF */
#define PUTA_TEST_RAM       0x8000  /* ()    ( ) */
                       /* ..0xFFFF */

#define VDRQ_COUNT  16              /*     VendorDeviceRequest */
/*================================================================================================*/

/*================================================================================================*/
typedef void (*USB_request_Handler)(void);
/*================================================================================================*/

/*================================================================================================*/
extern USB_request_Handler VendorDeviceRequest[VDRQ_COUNT];
/*================================================================================================*/

#endif /* USBCMD_H_ */
