#ifndef GLOBDEFS_H_
#define GLOBDEFS_H_

/*================================================================================================*/
#define VER_MAJOR   3
#define VER_MINOR   5

#ifdef __IAR_SYSTEMS_ICC__

#include "Configure_USB.h"

/*================================================================================================*/
/*        */
#define MAIN_RESET_DEVICE           0x8000
#define MAIN_JUMP_TO_BOOTROM        0x4000
#define MAIN_ENTER_SLEEP_MODE       0x2000
#define MAIN_EXIT_SLEEP_MODE        0x1000

/*        USB SUSPEND */
#define MAIN_SLEEP_ON_USB_SUSPEND   0

/*   */
#define MODULE_NAME  "E140\0\0"
/*================================================================================================*/

/*================================================================================================*/
typedef struct
    {
    unsigned char VerMinor, VerMajor;
    unsigned char Date[14];
    }
    t_VersionInfo;
/*================================================================================================*/

/*================================================================================================*/
extern unsigned int g_MainFlag;
extern const char ModuleName[7];
extern const t_VersionInfo VersionInfo;
/*================================================================================================*/

/*================================================================================================*/
/*------------------------------------------------------------------------------------------------*/
int SetLowPowerMode                 /*     */
    (
    int LowPower                    /* ()  -   (1)   (0)  */
    );                              /*  1  , 0   */
/*------------------------------------------------------------------------------------------------*/
/*================================================================================================*/
#endif /* __IAR_SYSTEMS_ICC__ */
#endif /* GLOBDEFS_H_ */
